/* clisti.c */
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "dpmish.h"

void fail(const char *s, ...)           { puts(s); _dos_exit(1); }

#define ITER	1000000L

int pe(void)    // is processor Protect Enable bit set?
{
    _asm smsw ax
    _asm and ax, 1
    // retval in AX
}

void clisti_loop(int pmode)
{
	time_t t1, t2;
	unsigned long i;
	printf("%s mode: ", pmode? "Prot" : pe() ? " V86" : "Real");
	time(&t1); 
	for (i=0; i<ITER; i++)
	{
		_asm cli
		_asm sti
	}
	time(&t2);
	printf("%lu CLI/STI in %lu seconds\n", ITER, t2-t1);
}

int real_main(int argc, char *argv[])   { clisti_loop(0); return 0; }
int pmode_main(int argc, char *argv[])	{ clisti_loop(1); return 0; }

