/* DOSMEM.C */

#include <stdlib.h>
#include <stdio.h>
#include "windows.h"

#define MK_FP(seg,ofs) ((void far *)(((DWORD)(seg) << 16) | (ofs)))

extern "C" void far pascal NoHookDosCall(void);

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,
    LPSTR lpszCmdLine, int nCmdShow)
{
	char buf[80];
        DWORD huge *fp, huge *fp2;
	DWORD limit, size, i;
	WORD segment, avail;

	/* call DOS Allocate Memory function */
	_asm mov ah, 48h
	_asm mov bx, 0FFFEh	
#if 1
        NoHookDosCall();
#else
	_asm int 21h
#endif		
	_asm jc alloc_error
	_asm mov segment, ax
        fp = (DWORD huge *) MK_FP(segment, 0);
		
	/* ask Windows how big it is:  limit = last valid byte offset */
	limit = GetSelectorLimit(segment);

	/* touch every byte of the allocated block */
	size = limit / sizeof(DWORD);
	for (i=0, fp2=fp; i <= size; i++, fp2++)
		*fp2 = i;
			
	sprintf(buf, "Allocated %lu bytes at %Fp", limit + 1, fp);
	MessageBox(0, buf, "DOSMEM", MB_OK);
	
	/* don't free block until user clicks Ok */
	_asm mov ah, 49h
	_asm mov es, segment
#if 1
        NoHookDosCall();
#else
	_asm int 21h
#endif		
	_asm jc free_error
	return 0;

free_error:
	MessageBox(0, "Error: couldn't free block!", "DOSMEM", MB_OK);
	return 1;

alloc_error:
	_asm mov avail, bx
	sprintf(buf, "Only %04Xh paragraphs available", avail);
	MessageBox(0, buf, "DOSMEM", MB_OK);
	return 1;
}



