/*
PE.C -- Test PE (protect enable) bit in machine status word (MSW)
Andrew Schulman, February 1992
from "Undocumented DOS", 2nd edition (Addison-Wesley, 1992)

bcc -2 pe.c
*/

#include <stdio.h>

main()
{
	unsigned msw;
	unsigned iopl;
	
	_asm pushf
	_asm pop ax
	_asm shr ax, 12
	_asm and ax, 3
	_asm mov word ptr iopl, ax
	printf("IOPL=%d\n", iopl);	
		
	_asm smsw ax		/* Store Machine Status Word: low CR0 */
	_asm mov msw, ax
	printf("PE (protect enable) bit %s\n", 
		(msw & 1) ? "SET" : "NOT set");
	return (msw & 1);
}

