/* TEST1600.C */

#include <stdlib.h>
#include <stdio.h>
#include <dos.h>

main()
{
	union REGS r;
	struct SREGS s;
	void (interrupt far *int2f)(void);	// will do pushf
	unsigned char retval, retval2;
	
	_asm mov ax, 1600h
	_asm int 2fh
	_asm mov retval, al
	printf("Via INT,   2F/1600 returns %02Xh\n", retval);

	// sometimes int86() is implemented with a far call!
	r.x.ax = 0x1600;
	segread(&s);
	int86x(0x2f, &r, &r, &s);
	printf("Via int86x, 2F/1600 returns %02Xh\n", r.h.al);

	int2f = (void (interrupt far *)(void)) _dos_getvect(0x2f);
	_asm mov ax, 1600h
	_asm cli			// Borland forgets to do this for (*intfunc)()
	(*int2f)();			// equivalent to pushf, far call
	_asm mov retval2, al
	printf("Via CALL,  2F/1600 returns %02Xh\n", retval2);

	if (retval2 == retval)
		printf("\nPUSHF/FAR CALL acts same as INT\n");
	else
		printf("\nPUSHF/FAR CALL not same as INT!\n");

	return 0;
}

