/* vxdfunc.h */

#define CHICAGO

char *VMM_Tbl[] = {
	"Get_VMM_Version", 
	"Get_Cur_VM_Handle", 
	"Test_Cur_VM_Handle", 
	"Get_Sys_VM_Handle",
	"Test_Sys_VM_Handle",
	"Validate_VM_Handle",
	"Get_VMM_Reenter_Count",
	"Begin_Reentrant_Execution",
	"End_Reentrant_Execution",
	"Install_V86_Break_Point",
	"Remove_V86_Break_Point",
	"Allocate_V86_Call_Back",
	"Allocate_PM_Call_Back",
	"Call_When_VM_Returns",
	"Schedule_Global_Event",
	"Schedule_VM_Event",
	"Call_Global_Event",
	"Call_VM_Event",
	"Cancel_Global_Event",
	"Cancel_VM_Event",
	"Call_Priority_VM_Event",
	"Cancel_Priority_VM_Event",
	"Get_NMI_Handler_Addr",
	"Set_NMI_Handler_Addr",
	"Hook_NMI_Event",
	"Call_When_VM_Ints_Enabled",
	"Enable_VM_Ints",
	"Disable_VM_Ints",
	"Map_Flat",
	"Map_Lin_To_VM_Addr",
	"Adjust_Exec_Priority",
	"Begin_Critical_Section",
	"End_Critical_Section",
	"End_Crit_And_Suspend",
	"Claim_Critical_Section",
	"Release_Critical_Section",
	"Call_When_Not_Critical",
	"Create_Semaphore",
	"Destroy_Semaphore",
	"Wait_Semaphore",
	"Signal_Semaphore",
	"Get_Crit_Section_Status",
	"Call_When_Task_Switched",
	"Suspend_VM",
	"Resume_VM",
	"No_Fail_Resume_VM",
	"Nuke_VM",
	"Crash_Cur_VM",
	"Get_Execution_Focus",
	"Set_Execution_Focus",
	"Get_Time_Slice_Priority",
	"Set_Time_Slice_Priority",
	"Get_Time_Slice_Granularity",
	"Set_Time_Slice_Granularity",
	"Get_Time_Slice_Info",
	"Adjust_Execution_Time",
	"Release_Time_Slice",
	"Wake_Up_VM",
	"Call_When_Idle",
	"Get_Next_VM_Handle",
	"Set_Global_Time_Out",
	"Set_VM_Time_Out",
	"Cancel_Time_Out",
	"Get_System_Time",
	"Get_VM_Exec_Time",
	"Hook_V86_Int_Chain",
	"Get_V86_Int_Vector",
	"Set_V86_Int_Vector",
	"Get_PM_Int_Vector",
	"Set_PM_Int_Vector",
	"Simulate_Int",
	"Simulate_Iret",
	"Simulate_Far_Call",
	"Simulate_Far_Jmp",
	"Simulate_Far_Ret",
	"Simulate_Far_Ret_N",
	"Build_Int_Stack_Frame",
	"Simulate_Push",
	"Simulate_Pop",
	"_HeapAllocate",
	"_HeapReAllocate",
	"_HeapFree",
	"_HeapGetSize",
	"_PageAllocate",
	"_PageReAllocate",
	"_PageFree",
	"_PageLock",
	"_PageUnLock",
	"_PageGetSizeAddr",
	"_PageGetAllocInfo",
	"_GetFreePageCount",
	"_GetSysPageCount",
	"_GetVMPgCount",
	"_MapIntoV86",
	"_PhysIntoV86",
	"_TestGlobalV86Mem",
	"_ModifyPageBits",
	"_CopyPageTable",
	"_LinMapIntoV86",
	"_LinPageLock",
	"_LinPageUnLock",
	"_SetResetV86Pageable",
	"_GetV86PageableArray",
	"_PageCheckLinRange",
	"_PageOutDirtyPages",
	"_PageDiscardPages",
	"_GetNulPageHandle",
	"_GetFirstV86Page",
	"_MapPhysToLinear",
	"_GetAppFlatDSAlias",
	"_SelectorMapFlat",
	"_GetDemandPageInfo",
	"_GetSetPageOutCount",
	"Hook_V86_Page",
	"_Assign_Device_V86_Pages",
	"_DeAssign_Device_V86_Pages",
	"_Get_Device_V86_Pages_Array",
	"MMGR_SetNULPageAddr",
	"_Allocate_GDT_Selector",
	"_Free_GDT_Selector",
	"_Allocate_LDT_Selector",
	"_Free_LDT_Selector",
	"_BuildDescriptorDWORDs",
	"_GetDescriptor",
	"_SetDescriptor",
	"_MMGR_Toggle_HMA",
	"Get_Fault_Hook_Addrs",
	"Hook_V86_Fault",
	"Hook_PM_Fault",
	"Hook_VMM_Fault",
	"Begin_Nest_V86_Exec",
	"Begin_Nest_Exec",
	"Exec_Int",
	"Resume_Exec",
	"End_Nest_Exec",
	"Allocate_PM_App_CB_Area",
	"Get_Cur_PM_App_CB",
	"Set_V86_Exec_Mode",
	"Set_PM_Exec_Mode",
	"Begin_Use_Locked_PM_Stack",
	"End_Use_Locked_PM_Stack",
	"Save_Client_State",
	"Restore_Client_State",
	"Exec_VxD_Int",
	"Hook_Device_Service",
	"Hook_Device_V86_API",
	"Hook_Device_PM_API",
	"System_Control",
	"Simulate_IO",
	"Install_Mult_IO_Handlers",
	"Install_IO_Handler",
	"Enable_Global_Trapping",
	"Enable_Local_Trapping",
	"Disable_Global_Trapping",
	"Disable_Local_Trapping",
	"List_Create",
	"List_Destroy",
	"List_Allocate",
	"List_Attach",
	"List_Attach_Tail",
	"List_Insert",
	"List_Remove",
	"List_Deallocate",
	"List_Get_First",
	"List_Get_Next",
	"List_Remove_First",
	"_AddInstanceItem",
	"_Allocate_Device_CB_Area",
	"_Allocate_Global_V86_Data_Area",
	"_Allocate_Temp_V86_Data_Area",
	"_Free_Temp_V86_Data_Area",
	"Get_Profile_Decimal_Int",
	"Convert_Decimal_String",
	"Get_Profile_Fixed_Point",
	"Convert_Fixed_Point_String",
	"Get_Profile_Hex_Int",
	"Convert_Hex_String",
	"Get_Profile_Boolean",
	"Convert_Boolean_String",
	"Get_Profile_String",
	"Get_Next_Profile_String",
	"Get_Environment_String",
	"Get_Exec_Path",
	"Get_Config_Directory",
	"OpenFile",
	"Get_PSP_Segment",
	"GetDOSVectors",
	"Get_Machine_Info",
	"GetSet_HMA_Info",
	"Set_System_Exit_Code",
	"Fatal_Error_Handler",
	"Fatal_Memory_Error",
	"Update_System_Clock",
	"Test_Debug_Installed",
	"Out_Debug_String",
	"Out_Debug_Chr",
	"In_Debug_Chr",
	"Debug_Convert_Hex_Binary",
	"Debug_Convert_Hex_Decimal",
	"Debug_Test_Valid_Handle",
	"Validate_Client_Ptr",
	"Test_Reenter",
	"Queue_Debug_String",
	"Log_Proc_Call",
	"Debug_Test_Cur_VM",
	"Get_PM_Int_Type",
	"Set_PM_Int_Type",
	"Get_Last_Updated_System_Time",
	"Get_Last_Updated_VM_Exec_Time",
	// following for 3.1 -- where did these come from?
	// don't seem to be in \ddk\inc31\vmm.inc!!!
    "Test_DBCS_Lead_Byte",
    "_AddFreePhysPage",
    "_PageResetHandlePAddr",
    "_SetLastV86Page",
    "_GetLastV86Page",
    "_MapFreePhysReg",
    "_UnmapFreePhysReg",
    "_XchgFreePhysReg",
    "_SetFreePhysRegCalBk",
    "Get_Next_Arena",
    "Get_Name_Of_Ugly_TSR",
    "Get_Debug_Options",
    "Set_Physical_HMA_Alias",
    "_GetGlblRng0V86IntBase",
    "_Add_Global_V86_Data_Area",
    "GetSetDetailedVMError",
    "Is_Debug_Chr",
    "Clear_Mono_Screen",
    "Out_Mono_Chr",
    "Out_Mono_String",
    "Set_Mono_Cur_Pos",
    "Get_Mono_Cur_Pos",
    "Get_Mono_Chr",
    "Locate_Byte_In_ROM",
    "Hook_Invalid_Page_Fault",
    "Unhook_Invalid_Page_Fault",
    "Set_Delete_On_Exit_File",
	"Close_VM",
	"Enable_Touch_1st_Meg",			// debugging
	"Disable_Touch_1st_Meg",		// debugging
	"Install_Exception_Handler",	// ef
	"Remove_Exception_Handler",		// f0
	"Get_Crit_Status_No_Block",		// f1
#ifdef CHICAGO
	"_Schedule_VM_RTI_Event",
	"_Trace_Out_Service",
	"_Debug_Out_Service",
	"_Debug_Flags_Service",
	"VMMAddImportModuleName",
	"VMM_Add_DDB",
	"VMM_Remove_DDB",
	"_GetThreadTimeSlicePriority",
	"_SetThreadTimeSlicePriority",
	"Schedule_Thread_Event",
	"Cancel_Thread_Event",
	"Set_Thread_Time_Out",
	"Set_Async_Time_Out",
	"_AllocateThreadDataSlot",
	"_FreeThreadDataSlot",
	"_CreateMutex",
	"_DestroyMutex",
	"_GetMutexOwner",
	"Call_When_Thread_Switched",
	"VMMCreateThread",
	"VMMStartThread",
	"VMMTerminateThread",
	"Get_Cur_Thread_Handle",
	"Test_Cur_Thread_Handle",
	"Get_Sys_Thread_Handle",
	"Test_Sys_Thread_Handle",
	"Validate_Thread_Handle",
	"Get_Initial_Thread_Handle",
	"Test_Initial_Thread_Handle",
	"Debug_Test_Valid_Thread_Handle",
	"Debug_Test_Cur_Thread",
	"Get_VM_Handle_For_Thread",
	"Cancel_Call_When_Thread_Switched",
	"Get_Next_Thread_Handle",
	"Adjust_Thread_Exec_Priority",
	"_Deallocate_Device_CB_Area",
	"Remove_IO_Handler",
	"Remove_Mult_IO_Handlers",
	"Unhook_V86_Int_Chain",
	"Unhook_V86_Fault",
	"Unhook_PM_Fault",
	"Unhook_VMM_Fault",
	"Unhook_Device_Service",
	"_MMReserve",					// ????
	"_MMCommit",
	"_MMDecommit",
	"_MMRegisterPager",
	"_MMQueryPagerInfo",
	"_MMDeregisterPager",
	"_MMCreateContext",
	"_MMDestroyContext",
	"_MMAttach",
	"_MMFlush",
	"_MMCopy",
	"_MMCommitPhys",
	"_Register_Win32_Services",
	"Cancel_Call_When_Not_Critical",
	"Cancel_Call_When_Idle",
	"Cancel_Call_When_Task_Switched",
	"_Debug_Printf_Service",
	"_EnterMutex",
	"_LeaveMutex",
	"Simulate_VM_IO",
	"Signal_Semaphore_No_Switch",
	"_MMSwitchContext",
	"_MMModifyPermissions",
	"_MMQuery",
	"_EnterMustComplete",
	"_LeaveMustComplete",
	"_ResumeExecMustComplete",
	"_GetThreadTerminationStatus",
	"_GetInstanceInfo",
	"_ExecIntMustComplete",
	"_ExecVxDIntMustComplete",
#if 1
	 "Begin_V86_Serialization",
	 "Unhook_V86_Page",
	 "VMM_GetVxDLocationList",
	 "VMM_GetDDBList",
	 "Unhook_NMI_Event",
	 "Get_Instanced_V86_Int_Vector",
	 "Get_Set_Real_DOS_PSP",
      "Call_Priority_Thread_Event",
      "Get_System_Time_Address",
	 "Get_Crit_Status_Thread",
	 "Get_DDB",
	 "Directed_Sys_Control",
	 "_RegOpenKey",
	 "_RegCloseKey",
	 "_RegCreateKey",
	 "_RegDeleteKey",
	 "_RegEnumKey",
	 "_RegQueryValue",
	 "_RegSetValue",
	 "_RegDeleteValue",
	 "_RegEnumValue",
	 "_RegQueryValueEx",
	 "_RegSetValueEx",
	 "_CallRing3",
	 "Exec_PM_Int",
	 "_RegFlushKey",
	 "_PageCommitContig",
	 "_GetCurrentContext",
      "_LocalizeSprintf",
      "_LocalizeStackSprintf",
	 "Call_Restricted_Event",
	 "Cancel_Restricted_Event",
	 "Register_PEF_Provider",
      "_GetPhysPageInfo",
	 "_RegQueryInfoKey",
      "MemArb_Reserve_Pages",
      "Time_Slice_Sys_VM_Idle",
      "Time_Slice_Sleep",
      "Boost_With_Decay",
      "Set_Inversion_Pri",
      "Reset_Inversion_Pri",
      "Release_Inversion_Pri",
      "Get_Thread_Win32_Pri",
      "Set_Thread_Win32_Pri",
      "Set_Thread_Static_Boost",
      "Set_VM_Static_Boost",
      "Release_Inversion_Pri_ID",
      "Attach_Thread_To_Group",
      "Detach_Thread_From_Group",
      "Set_Group_Static_Boost",
	 "_GetRegistryPath",
	 "_GetRegistryKey",
	 "_CleanupNestedExec",
	 "_RegRemapPreDefKey",
	 "End_V86_Serialization",
	 "_Assert_Range",
	 "_Sprintf",
	 "_PageChangePager",
	 "_RegCreateDynKey",
	 "_RegQMulti",
      "Boost_Thread_With_VM",
#else
	"_FastV86MutexInit",
#endif		
#endif
} ;

char *VPICD_Tbl[] = {
	"~~",
	"~Virtualize_IRQ",
	"~Set_Int_Request",
	"~Clear_Int_Request",
	"~Phys_EOI",
	"~Get_Complete_Status",
	"~Get_Status",
	"~Test_Phys_Request",
	"~Physically_Mask",
	"~Physically_Unmask",
	"~Set_Auto_Masking",
	"~Get_IRQ_Complete_Status",
	"~Convert_Handle_To_IRQ",
	"~Convert_IRQ_To_Int",
	"~Convert_Int_To_IRQ",
	"~Call_When_Hw_Int",
	"~Force_Default_Owner",
	"~Force_Default_Behavior",
	"~Auto_Mask_At_Inst_Swap",		// 3.1
	"~Begin_Inst_Page_Swap",		// 3.1
	"~End_Inst_Page_Swap",			// 3.1
	"~Virtual_EOI",
} ; 

char *DOSMGR_Tbl[] = {
	"~~",
	"_DOSMGR_Set_Exec_VM_Data",
	"~Copy_VM_Drive_State",
	"_DOSMGR_Exec_VM",
	"~Get_IndosPtr",
	"~Add_Device",
	"~Remove_Device",
	"~Instance_Device",
	"~Get_DOS_Crit_Status",
	"~Enable_Indos_Polling",
    // following for 3.1+
    "~BackFill_Allowed",
    "~LocalGlobalReg",
	"~Init_UMB_Area",
	"~Begin_V86_App",
	"~End_V86_App",
	"~Alloc_Local_Sys_VM_Mem",
} ;

char *DOSNET_Tbl[] = {
	"~~",
	"~Send_FILESYSCHANGE",
	"~Do_PSP_Adjust",
} ;

char *EBIOS_Tbl[] = {
	"~~",
	// following is for 3.1+
	"~Get_Unused_Mem",
} ;

char *PageSwap_Tbl[] = {
	"~~",
	"~Test_Create",
	"~Create",
	"~Destroy",
	"~In",
	"~Out",
	"~Test_IO_Valid",
	"~Read_Or_Write",
	"~Grow_File",
	"~Init_File",
} ;

char *SHELL_Tbl[] = {
	"~~",
	"~Resolve_Contention",
	"~Event",
	"~SYSMODAL_Message",
	"~Message",
	// following is for 3.1+
	"~GetVMInfo",
#ifdef CHICAGO
/// following may be wrong -- see new shell.inc!
	"_SHELL_PostMessage",
	"_SHELL_WinExec",
	"_SHELL_CallDll",
	"~OpenClipboard",
	"~SetClipboardData",
	"~GetClipboardData",
	"~CloseClipboard",
	"_SHELL_Install_Taskman_Hooks",
	"~Hook_Properties",
	"~Unhook_Properties",
	"~OEMKeyScan",
	"~Update_User_Activity",
#endif
} ;

char *V86MMGR_Tbl[] = {
     "~~",
     "~Allocate_V86_Pages",
     "~Set_EMS_XMS_Limits",
     "~Get_EMS_XMS_Limits",
     "~Set_Mapping_Info",
     "~Get_Mapping_Info",
     "~Xlat_API",
     "~Load_Client_Ptr",
     "~Allocate_Buffer",
     "~Free_Buffer",
     "~Get_Xlat_Buff_State",
     "~Set_Xlat_Buff_State",
     "~Get_VM_Flat_Sel",
     "~Map_Pages",
     "~Free_Page_Map_Region",
	 // following for 3.1+
     "~LocalGlobalReg",
     "~GetPgStatus",
	 "~SetLocalA20",
     "~ResetBasePages",
	 "~SetAvailMapPgs",
	 "~NoUMBInitCalls",
	 "~Get_EMS_XMS_Avail",
	 "~Toggle_HMA",
	 "~Dev_Init",
	 "~Alloc_UM_Page",
} ;

char *VCD_Tbl[] = {
	"~~",
	"~Set_Port_Global",
	"~Get_Focus",
	"~Virtualize_Port",
} ;

char *VDD_Tbl[] = {
	"~~",
	"~PIF_State",
	"~Get_GrabRtn",
	"~Hide_Cursor",
	"~Set_VMType",
	"~Get_ModTime",
	"~Set_HCurTrk",
	"~Msg_ClrScrn",
	"~Msg_ForColor",
	"~Msg_BakColor",
	"~Msg_TextOut",
	"~Msg_SetCursPos",
	"~Query_Access",
	"~Check_Update_Soon",	// 3.1
} ;

// VDD2 is probably bogus; will usually be LoadHi (EMM386, 386MAX, QEMM)
char *VDD2_Tbl[] = {
	"VDD2_Get_Version",
} ;

char *LoadHi_Tbl[] = {
	"LoadHi_Get_Version",
} ;

char *VMCPD_Tbl[] = {
	"~~",
	"~Get_Virt_State",
	"~Set_Virt_State",
	} ;

/*
	or, VMCPD (Virtual Math Coprocessor Device) may have????
		VMCPD_SysInit
		VMCPD_INT_7
*/			

char *VDMAD_Tbl[] = {
	"~~",
	"~Virtualize_Channel",
	"~Get_Region_Info",
	"~Set_Region_Info",
	"~Get_Virt_State",
	"~Set_Virt_State",
	"~Set_Phys_State",
	"~Mask_Channel",
	"~UnMask_Channel",
	"~Lock_DMA_Region",
	"~Unlock_DMA_Region",
	"~Scatter_Lock",
	"~Scatter_Unlock",
	"~Reserve_Buffer_Space",
	"~Request_Buffer",
	"~Release_Buffer",
	"~Copy_To_Buffer",
	"~Copy_From_Buffer",
	"~Default_Handler",
	"~Disable_Translation",
	"~Enable_Translation",
	"~Get_EISA_Adr_Mode",
	"~Set_EISA_Adr_Mode",
	"~Unlock_DMA_Region_No_Dirty",
} ;

char *VKD_Tbl[] = {
	"~~",
	"~Define_Hot_Key",
	"~Remove_Hot_Key",
	"~Local_Enable_Hot_Key",
	"~Local_Disable_Hot_Key",
	"~Reflect_Hot_Key",
	"~Cancel_Hot_Key_State",
	"~Force_Keys",
	"~Get_Kbd_Owner",
	"~Define_Paste_Mode",
	"~Start_Paste",
	"~Cancel_Paste",
	"~Get_Msg_Key",
	"~Peek_Msg_Key",
	"~Flush_Msg_Key_Queue",
} ;

// VHD gone -- see BlockDev!
char *VHD_Tbl[] = {
    "~~",
    "~Allocate_Handle",
    "~Read",
    "~Write",
    "~Get_Status",
} ;

// now IOS
char *BlockDev_Tbl[] = {
    "~~",
    "~Register_Device",
    "~Find_Int13_Drive",
    "~Get_Device_List",
    "~Send_Command",
    "~Command_Complete",
    "~Synchronous_Command",
#ifdef CHICAGO
	// make sure these are correct!!
	"~Register",
	"~Requestor_Service",
	"~Exclusive_Access",
	"~Send_Next_Command",
	"~Set_Async_Time_Out",
	"~Signal_Semaphore_No_Switch",
	"IOSIdleStatus",
	"IOSMapIORSToI24",
	"IOSMapIORSToI21",
#endif		
} ;

char *VMD_Tbl[] = {
	"~~",
	"~Set_Mouse_Type",
	"~Get_Mouse_Owner",
	"~Post_Pointer_Message",
	"~Set_Cursor_Proc",
	"~Call_Cursor_Proc",
	"~Set_Mouse_Data"
	"~Get_Mouse_Data",
	"~Manipulate_Pointer_Message",
	"~Set_Middle_Button",
} ;

char *VMPoll_Tbl[] = {
	"~~",
	"~Enable_Disable",
    // following for 3.1+
    "~Reset_Detection",
	"~Check_Idle",
} ;

char *VNETBIOS_Tbl[] = {
	"~~",
	"~Register",
	"~Submit",
	"~Enum",
	"~Deregister",
	"~Register2",
	"~Map",
	"~Enum2",
} ;

char *VSD_Tbl[] = {
	"~~",
	"~Bell",
	"~SoundOn",
	"~TakeSoundPort",
} ;

char *VTD_Tbl[] = {
	"~~",
	"~Update_System_Clock",
	"~Get_Interrupt_Period",
	"~Begin_Min_Int_Period",
	"~End_Min_Int_Period",
	"~Disable_Trapping",
	"~Enable_Trapping",
	// following probably 3.1+
	"~Get_Real_Time",
	"~Get_Date_And_Time",
} ;

char *INT13_Tbl[] = {
	"~~",
	"~Device_Registered",
	"~Translate_VM_Int",
	"~Hooking_BIOS_Int",
	"~Unhooking_BIOS_Int",
} ; 

char *PageFile_Tbl[] = {
	"~~",
	"~Init_File",
	"~Clean_Up",
	"~Grow_File",
	"~Read_Or_Write",
	"~Cancel",
	"~Test_IO_Valid",
	"~Get_Size_Info",
	"~Set_Async_Manager",
	"~Call_Async_Manager",
} ; 

char *VXDLDR_Tbl[] = {
	"~~",
	"~LoadDevice",
	"~UnloadDevice",
	"~DevInitSucceeded",
	"~DevInitFailed",
	"~GetDeviceList",
	"~UnloadMe",
   "PELDR_LoadModule",
   "PELDR_GetModuleHandle",
   "PELDR_GetModuleUsage",
   "PELDR_GetEntryPoint",
   "PELDR_GetProcAddress",
   "PELDR_AddExportTable",
   "PELDR_RemoveExportTable",
   "PELDR_FreeModule",
} ;
		
char *NDIS_Tbl[] = {
	"NdisGetVersion",
	"NdisAllocateSpinLock",
	"NdisFreeSpinLock",
	"NdisAcquireSpinLock",
	"NdisReleaseSpinLock",
	"NdisOpenConfiguration",
	"NdisReadConfiguration",
	"NdisCloseConfiguration",
	"NdisReadEisaSlotInformation",
	"NdisReadMcaPosInformation",
	"NdisAllocateMemory",
	"NdisFreeMemory",
	"NdisSetTimer",
	"NdisCancelTimer",
	"NdisStallExecution",
	"NdisInitializeInterrupt",
	"NdisRemoveInterrupt",
	"NdisSynchronizeWithInterrupt",
	"NdisOpenFile",
	"NdisMapFile",
	"NdisUnmapFile",
	"NdisCloseFile",
	"NdisAllocatePacketPool",
	"NdisFreePacketPool",
	"NdisAllocatePacket",
	"NdisReinitializePacket",
	"NdisFreePacket",
	"NdisQueryPacket",
	"NdisAllocateBufferPool",
	"NdisFreeBufferPool",
	"NdisAllocateBuffer",
	"NdisCopyBuffer",
	"NdisFreeBuffer",
	"NdisQueryBuffer",
	"NdisGetBufferPhysicalAddress",
	"NdisChainBufferAtFront",
	"NdisChainBufferAtBack",
	"NdisUnchainBufferAtFront",
	"NdisUnchainBufferAtBack",
	"NdisGetNextBuffer",
	"NdisCopyFromPacketToPacket",
	"NdisRegisterProtocol",
	"NdisDeregisterProtocol",
	"NdisOpenAdapter",
	"NdisCloseAdapter",
	"NdisSend",
	"NdisTransferData",
	"NdisReset",
	"NdisRequest",
	"NdisInitializeWrapper",
	"NdisTerminateWrapper",
	"NdisRegisterMac",
	"NdisDeregisterMac",
	"NdisRegisterAdapter",
	"NdisDeregisterAdapter",
	"NdisCompleteOpenAdapter",
	"NdisCompleteCloseAdapter",
	"NdisCompleteSend",
	"NdisCompleteTransferData",
	"NdisCompleteReset",
	"NdisCompleteRequest",
	"NdisIndicateReceive",
	"NdisIndicateReceiveComplete",
	"NdisIndicateStatus",
	"NdisIndicateStatusComplete",
	"NdisCompleteQueryStatistics",
	"NdisEqualString",
	"NdisNetAddressStringToBinary",
	"NdisReadNetworkAddress",
	"NdisWriteErrorLogEntry",
	"C_MapPhysToLinear",
	"C_HeapFree",
	"NdisAllocateSharedMemory",
	"NdisFreeSharedMemory",
} ;
	
char *VWIN32_Tbl[] = {
	"VWin32_Get_Version",
	"VWin32_Wake_For_Event",
	"_VWIN32_QueueUserApc",
	"_VWIN32_Get_Thread_Context",
	"_VWIN32_Set_Thread_Context",
	"_VWIN32_CopyMem",
	"_VWIN32_BlockForTermination",
} ; 

char *VCOMM_Tbl[] = {
	"~~",
	"_VCOMM_Register_Port_Driver",
	"_VCOMM_Acquire_Port",
	"_VCOMM_Release_Port",
	"_VCOMM_OpenComm",
	"_VCOMM_SetCommState",
	"_VCOMM_GetCommState",
	"_VCOMM_SetupComm",
	"_VCOMM_TransmitCommChar",
	"_VCOMM_CloseComm",
	"_VCOMM_GetCommQueueStatus",
	"_VCOMM_ClearCommError",
	"_VCOMM_GetModemStatus",
	"_VCOMM_GetCommProperties",
	"_VCOMM_EscapeCommFunction",
	"_VCOMM_PurgeComm",
	"_VCOMM_SetCommEventMask",
	"_VCOMM_GetCommEventMask",
	"_VCOMM_WriteComm",
	"_VCOMM_ReadComm",
	"_VCOMM_EnableCommNotification",
	"_VCOMM_GetLastError",
	"_VCOMM_Steal_Port",
	"_VCOMM_SetReadCallBack",
	"_VCOMM_SetWriteCallBack",
	"_VCOMM_GetSetCommTimeouts",
	"_VCOMM_SetWriteRequest",
	"_VCOMM_SetReadRequest",
	"_VCOMM_Dequeue_Request",
} ;

char *IFSMgr_Tbl_2[] = {
	"~Get_Version",
	"~RegisterMount",
	"~RegisterNet",
	"~RegisterMailSlot",
	"~Attach",
	"~Detach",
	"~Get_NetTime",
	"~Get_DOSTime",
	"~SetupConnection",
	"~DerefConnection",
	"~ServerDOSCall",
	"~CompleteAsync",
	"~RegisterHeap",
	"~GetHeap",
	"~RetHeap",
	"~CheckHeap",
	"~CheckHeapItem",
	"~FillHeapSpare",
	"~Block",
	"~Wakeup",
	"~Yield",
	"~SchedEvent",
	"~QueueEvent",
	"~KillEvent",
	"~FreeIOReq",
	"~MakeMailSlot",
	"~DeleteMailSlot",
	"~WriteMailSlot",
	"~PopUp",
	"~printf",
	"~AssertFailed",
	"~LogEntry",
	"~DebugMenu",
	"~DebugVars",
	"~GetDebugString",
	"~GetDebugHexNum",
	"~NetFunction",
	"~DoDelAllUses",
	"~SetErrString",
	"~GetErrString",
	"~SetReqHook",
	"~SetPathHook",
	"~UseAdd",
	"~UseDel",
	"~InitUseAdd",
	"~ChangeDir",
	"~DelAllUses",
	"~CDROM_Attach",
	"~CDROM_Detach",
	"~Win32DupHandle",
	"~Ring0_FileIO",
	"~Toggle_Extended_File_Handles",
	"~Get_Drive_Info",
	"~Ring0GetDriveInfo",
	"~BlockNoEvents",
	"~NetToDosTime",
	"~DosToNetTime",
	"~DosToWin32Time",
	"~Win32ToDosTime",
	"~NetToWin32Time",
	"~Win32ToNetTime",
	"~MetaMatch",
	"~TransMatch",
	"~CallProvider",
	"UniToBCS",
	"UniToBCSPath",
	"BCSToUni",
	"UniToUpper",
	"UniCharToOEM",
	"CreateBasis",
	"MatchBasisName",
	"AppendBasisTail",
	"FcbToShort",
	"ShortToFcb",
	"~ParsePath",
	"Query_PhysLock",
	"_VolFlush",
	"NotifyVolumeArrival",
	"NotifyVolumeRemoval",
	"QueryVolumeRemoval",
	"~FSDUnmountCFSD",
	"~GetConversionTablePtrs",
	"~CheckAccessConflict",
	"~LockFile",
	"~UnlockFile",
	"~RemoveLocks",
	"~CheckLocks",
	"~CountLocks",
	"~ReassignLockFileInst",
	"~UnassignLockList",
	"~MountChildVolume",
	"~UnmountChildVolume",
	"~SwapDrives",
	"~FSDMapFHtoIOREQ",
	"~FSDParsePath",
	"~FSDAttachSFT",
	"~GetTimeZoneBias",
	"~PNPEvent",
	"~RegisterCFSD",
	"~Win32MapExtendedHandleToSFT",
	"~DbgSetFileHandleLimit",
	"~Win32MapSFTToExtendedHandle",
	"~FSDGetCurrentDrive",
} ;

char *IFSMgr_Tbl[] = {
	"~~",
	"~RegisterMount",
	"~RegisterNet",
	"~RegisterMailSlot",
	"~Attach",
	"~Detach",
	"~Get_NetTime",
	"~Get_DOSTime",
	"~SetupConnection",
	"~DerefConnection",
	"~ServerDOSCall",
	"~CompleteAsync",
	"~RegisterHeap",
	"~GetHeap",
	"~RetHeap",
	"~CheckHeap",
	"~CheckHeapItem",
	"~FillHeapSpare",
	"~Block",
	"~Wakeup",
	"~Yield",
	"~SchedEvent",
	"~QueueEvent",
	"~KillEvent",
	"~FreeIOReq",
	"~MakeMailSlot",
	"~DeleteMailSlot",
	"~WriteMailSlot",
	"~PopUp",
	"~CaseMapString",
	"~GetCaseMapTable",
	"~printf",
	"~AssertFailed",
	"~LogEntry",
	"~DebugMenu",
	"~DebugVars",
	"~GetDebugString",
	"~GetDebugHexNum",
	"~NetFunction",
	"~DoDelAllUses",
	"~SetErrString",
	"~GetErrString",
	"~SetReqHook",
	"~SetPathHook",
	"~UseAdd",
	"~UseDel",
	"~InitUseAdd",
	"~ChangeDir",
	"~DelAllUses",
	"~CDROM_Attach",
	"~CDROM_Detach",
	"~LFNAnsiToOem",
	"~LFNOemToAnsi",
	"~LFNMetaMatchAnsiNames",
	"~LFNMatchAnsiNames",
	"~Win32DupHandle",
	"~Ring0_FileIO",
	"~Toggle_Extended_File_Handles",
	"~Get_Drive_Info",
	"~Ring0GetDriveInfo",
	"~BlockNoEvents",
	"~NetToDosTime",
	"~DosToNetTime",
	"~DosToWin32Time",
	"~Win32ToDosTime",
	"~NetToWin32Time",
	"~Win32ToNetTime",
	"~MetaMatch",
	"~TransMatch",
	"~CallProvider",
	"UniToBCS",
	"UniToBCSPath",
	"BCSToUni",
	"UniToUpper",
	"UniCharToOEM",
	"CreateBasis",
	"MatchBasisName",
	"AppendBasisTail",
	"FcbToShort",
	"ShortToFcb",
	"~ParsePath",
	"Query_PhysLock",
	"_VolFlush",
	"NotifyVolumeArrival",
	"NotifyVolumeRemoval",
	"QueryVolumeRemoval",
	"~FSDUnmountCFSD",
	"~GetConversionTablePtrs",
	"~CheckAccessConflict",
	"~LockFile",
	"~UnlockFile",
	"~RemoveLocks",
	"~CheckLocks",
	"~CountLocks",
	"~ReassignLockFileInst",
	"~UnassignLockList",
	"~MountChildVolume",
	"~UnmountChildVolume",
	"~SwapDrives",
	"~FSDMapFHtoIOREQ",
	"~FSDParsePath",
	"~FSDAttachSFT",
	"~GetTimeZoneBias",
	"~PNPEvent",
	"~RegisterCFSD",
	"~Win32MapExtendedHandleToSFT",
	"~DbgSetFileHandleLimit",
	"~Win32MapSFTToExtendedHandle",
	"~FSDGetCurrentDrive",
} ;
		
char *VCACHE_Tbl[] = {
	"~~",
	"~Register",
	"~GetSize",
	"~CheckAvail",
	"~FindBlock",
	"~FreeBlock",
	"~MakeMRU",
	"~Hold",
	"~Unhold",
	"~Enum",
	"~TestHandle",
	"~VerifySums",
	"~RecalcSums",
	"~TestHold",
	"~GetStats",
} ;
		
typedef struct {
	void *tbl;
	unsigned size;
	char *desc;
	} VxD_Tbl_Desc; 
	
#define TBL_SIZE(tbl)		((sizeof(tbl) / sizeof(char*)))

VxD_Tbl_Desc VxD_Tbl[] = {
	/* 0000 */				0, 0,
		0,
	/* 0001 = VMM */		VMM_Tbl, TBL_SIZE(VMM_Tbl),
		"Virtual Machine Manager",
	/* 0002 = Debug */		0, 0,
		"Win386 Debug Device",
	/* 0003 = VPICD */		VPICD_Tbl, TBL_SIZE(VPICD_Tbl), 
		"Virtual Programmable Interrupt Controller (PIC) Device",
	/* 0004 = VDMAD */		VDMAD_Tbl, TBL_SIZE(VDMAD_Tbl), 
		"Virtual Direct Memory Access (DMA) Device",
	/* 0005 = VTD */		VTD_Tbl, TBL_SIZE(VTD_Tbl), 
		"Virtual Timer Device",
	/* 0006 = V86MMGR */	V86MMGR_Tbl, TBL_SIZE(V86MMGR_Tbl), 
		"Virtual 8086 (V86) Mode Memory Manager Device",
	/* 0007 = PageSwap */	PageSwap_Tbl, TBL_SIZE(PageSwap_Tbl), 
		"Demand Paging Swap Device Services",
	/* 0008 = Parity */		0, 0,
		0,
	/* 0009 = Reboot */		0, 0,
		0,
	/* 000A = VDD */		VDD_Tbl, TBL_SIZE(VDD_Tbl), 
		"Virtual Display Device",
	/* 000B = VSD */		VSD_Tbl, TBL_SIZE(VSD_Tbl), 
		"Virtual Sound Device",
	/* 000C = VMD */		VMD_Tbl, TBL_SIZE(VMD_Tbl), 
		"Virtual Mouse Device",
	/* 000D = VKD */		VKD_Tbl, TBL_SIZE(VKD_Tbl), 
		"Virtual Keyboard Device",
	/* 000E = VCD */		VCD_Tbl, TBL_SIZE(VCD_Tbl), 
		"Virtual COMM Device",
	/* 000F = VPD */		0, 0,
		"Virtual Printer Device",
			
	// has been renamed again:  IOS!!
#if 1
	// Windows 3.1+
	/* 0010 = BlockDev */	BlockDev_Tbl, TBL_SIZE(BlockDev_Tbl),
		"Block Device (formerly VHD)",
#else
	// Windows 3.0
	/* 0010 = VHD */		VHD_Tbl, TBL_SIZE(VHD_Tbl), 
		"Virtual Hard Disk Device",
#endif			
	/* 0011 = VMCPD */		VMCPD_Tbl, TBL_SIZE(VMCPD_Tbl),
		"Virtual Math Coprocessor (MCP) Device",
	/* 0012 = EBIOS */		EBIOS_Tbl, TBL_SIZE(EBIOS_Tbl), 
		0,
	/* 0013 = BIOSXlat */	0, 0,
		0,
	/* 0014 = VNETBIOS */	VNETBIOS_Tbl, TBL_SIZE(VNETBIOS_Tbl), 
		"Virtual NetBIOS Device",
	/* 0015 = DOSMGR */		DOSMGR_Tbl, TBL_SIZE(DOSMGR_Tbl), 
		0,
	/* 0016 = WINLOAD */	0, 0,
		0,
	/* 0017 = SHELL */		SHELL_Tbl, TBL_SIZE(SHELL_Tbl), 
		0,
	/* 0018 = VMPoll */		VMPoll_Tbl, TBL_SIZE(VMPoll_Tbl), 
		0,
	/* 0019 = VPROD */		0, 0,
		0,
	/* 001A = DOSNET */		DOSNET_Tbl, TBL_SIZE(DOSNET_Tbl), 
		0,
	/* 001B = VFD */		0, 0,
		"Virtual Floppy Device",
#if 1
	/* 001C = LoadHi */		LoadHi_Tbl, TBL_SIZE(LoadHi_Tbl), 
		0,
#else
	/* 001C = VDD2 */		VDD2_Tbl, TBL_SIZE(VDD2_Tbl), 
		"Virtual Secondary Display Driver",
#endif			
	/* 001D = WINDEBUG */	0, 0,
		0,
	/* 001E = TSRLoad */	0, 0,
		"TSR instance utility",
	/* 001F = BiosHook */	0, 0,
		"BIOS interrupt hooker VxD",
	/* 0020 = INT13 */		INT13_Tbl, TBL_SIZE(INT13_Tbl),
		0,
	/* 0021 = PageFile */	PageFile_Tbl, TBL_SIZE(PageFile_Tbl),
		"Demand Paging Swap Device Services",
	/* 0022 = SCSI */		0, 0,
		0,
	/* 0023 = MCA_POS */	0, 0,
		"Microchannel Architecture Programmable Option Select",
	/* 0024 = SCSIFD */		0, 0,
		"SCSI FastDisk",
	/* 0025 = VPEND */		0, 0,
		"Virtual Pen Device",
	/* 0026 = APM */		0, 0,
		"Power Management Device",
	/* 0027 = VXDLDR */		VXDLDR_Tbl, TBL_SIZE(VXDLDR_Tbl),
		"Dynamic VxD Loader",
	/* 0028 = NDIS */		NDIS_Tbl, TBL_SIZE(NDIS_Tbl),
		"NDIS",
	/* 0029 = ???? */		0, 0,
		"",
	/* 002A = VWIN32 */		VWIN32_Tbl, TBL_SIZE(VWIN32_Tbl),
		"VWIN32",
	/* 002B = VCOMM */		VCOMM_Tbl, TBL_SIZE(VCOMM_Tbl),
		"VCOMM",
	} ;
		
#define NUM_DEV		(sizeof(VxD_Tbl) / sizeof(VxD_Tbl_Desc))

typedef struct {
	unsigned devnum;
	void *tbl;
	unsigned size;
	char *desc;
	} VxD_Tbl2_Desc; 
	
VxD_Tbl2_Desc VxD_Tbl2[] = {
	0x484, IFSMgr_Tbl, TBL_SIZE(IFSMgr_Tbl),
		"32-bit file access Installable File System (IFS) Manager: WfW 3.11",
	// in Chicago, IFSMgr is VxD # 40; in WfW 3.11, # 484 ???
	0x40, IFSMgr_Tbl_2, TBL_SIZE(IFSMgr_Tbl_2),
		"32-bit file access Installable File System (IFS) Manager: Chicago",
	0x48B, VCACHE_Tbl, TBL_SIZE(VCACHE_Tbl),
		"32-bit file access Virtual File Cache",
	} ;

#define NUM2_DEV		(sizeof(VxD_Tbl2) / sizeof(VxD_Tbl2_Desc))

			